IntPoint (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.document, class: IntPoint

Package org.apache.lucene.document

# Class IntPoint

java.lang.Object
org.apache.lucene.document.Field
org.apache.lucene.document.IntPoint

All Implemented Interfaces:
  `IndexableField`

public final class IntPoint extends Field
An indexed `int` field for fast range filters. If you also need to store the value, you should add a separate `StoredField` instance.

Finding all documents within an N-dimensional shape or range at search time is efficient. Multiple values for the same field in one document is allowed.

This field defines static factory methods for creating common queries:

- `newExactQuery(String, int)` for matching an exact 1D point.
- `newSetQuery(String, int...)` for matching a set of 1D values.
- `newRangeQuery(String, int, int)` for matching a 1D range.
- `newRangeQuery(String, int[], int[])` for matching points/ranges in n-dimensional space.

See Also:
  - `PointValues`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.document.Field

  `Field.Store`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.document.Field

  `fieldsData, name, type`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IntPoint(String name, int... point)`
  Creates a new IntPoint, indexing the provided N-dimensional int point.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static int`
  `decodeDimension(byte[] value, int offset)`
  Decode single integer dimension
  `static void`
  `encodeDimension(int value, byte[] dest, int offset)`
  Encode single integer dimension
  `static Query`
  `newExactQuery(String field, int value)`
  Create a query for matching an exact integer value.
  `static Query`
  `newRangeQuery(String field, int[] lowerValue, int[] upperValue)`
  Create a range query for n-dimensional integer values.
  `static Query`
  `newRangeQuery(String field, int lowerValue, int upperValue)`
  Create a range query for integer values.
  `static Query`
  `newSetQuery(String field, int... values)`
  Create a query matching any of the specified 1D values.
  `static Query`
  `newSetQuery(String field, Collection<Integer> values)`
  Create a query matching any of the specified 1D values.
  `Number`
  `numericValue()`
  Non-null if this field has a numeric value
  `static BytesRef`
  `pack(int... point)`
  Pack an integer point into a BytesRef
  `void`
  `setBytesValue(BytesRef bytes)`
  Expert: change the value of this field.
  `void`
  `setIntValue(int value)`
  Expert: change the value of this field.
  `void`
  `setIntValues(int... point)`
  Change the values of this field
  `String`
  `toString()`
  Prints a Field for human consumption.

  ### Methods inherited from class org.apache.lucene.document.Field

  `binaryValue, fieldType, getCharSequenceValue, invertableType, name, readerValue, setBytesValue, setByteValue, setDoubleValue, setFloatValue, setLongValue, setReaderValue, setShortValue, setStringValue, setTokenStream, storedValue, stringValue, tokenStream, tokenStreamValue`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### IntPoint

    public IntPoint(String name, int... point)
    Creates a new IntPoint, indexing the provided N-dimensional int point.
    Parameters:
      `name` - field name
      `point` - int[] value
    Throws:
      `IllegalArgumentException` - if the field name or value is null.

- ## Method Details

  - ### setIntValue

    public void setIntValue(int value)
    Description copied from class: `Field`
    Expert: change the value of this field. See `Field.setStringValue(String)`.
    Overrides:
      `setIntValue` in class `Field`

  - ### setIntValues

    public void setIntValues(int... point)
    Change the values of this field

  - ### setBytesValue

    public void setBytesValue(BytesRef bytes)
    Description copied from class: `Field`
    Expert: change the value of this field. See `Field.setStringValue(String)`.

    NOTE: the provided BytesRef is not copied so be sure not to change it until you're done with this field.

    Overrides:
      `setBytesValue` in class `Field`

  - ### numericValue

    public Number numericValue()
    Description copied from interface: `IndexableField`
    Non-null if this field has a numeric value
    Specified by:
      `numericValue` in interface `IndexableField`
    Overrides:
      `numericValue` in class `Field`

  - ### pack

    public static BytesRef pack(int... point)
    Pack an integer point into a BytesRef
    Parameters:
      `point` - int[] value
    Throws:
      `IllegalArgumentException` - is the value is null or of zero length

  - ### toString

    public String toString()
    Description copied from class: `Field`
    Prints a Field for human consumption.
    Overrides:
      `toString` in class `Field`

  - ### encodeDimension

    public static void encodeDimension(int value, byte[] dest, int offset)
    Encode single integer dimension

  - ### decodeDimension

    public static int decodeDimension(byte[] value, int offset)
    Decode single integer dimension

  - ### newExactQuery

    public static Query newExactQuery(String field, int value)
    Create a query for matching an exact integer value.

    This is for simple one-dimension points, for multidimensional points use `newRangeQuery(String, int[], int[])` instead.

    Parameters:
      `field` - field name. must not be `null`.
      `value` - exact value
    Returns:
      a query matching documents with this exact value
    Throws:
      `IllegalArgumentException` - if `field` is null.

  - ### newRangeQuery

    public static Query newRangeQuery(String field, int lowerValue, int upperValue)
    Create a range query for integer values.

    This is for simple one-dimension ranges, for multidimensional ranges use `newRangeQuery(String, int[], int[])` instead.

    You can have half-open ranges (which are in fact </≤ or >/≥ queries) by setting `lowerValue = Integer.MIN_VALUE` or `upperValue = Integer.MAX_VALUE`.

    Ranges are inclusive. For exclusive ranges, pass `Math.addExact(lowerValue, 1)` or `Math.addExact(upperValue, -1)`.

    Parameters:
      `field` - field name. must not be `null`.
      `lowerValue` - lower portion of the range (inclusive).
      `upperValue` - upper portion of the range (inclusive).
    Returns:
      a query matching documents within this range.
    Throws:
      `IllegalArgumentException` - if `field` is null.

  - ### newRangeQuery

    public static Query newRangeQuery(String field, int[] lowerValue, int[] upperValue)
    Create a range query for n-dimensional integer values.

    You can have half-open ranges (which are in fact </≤ or >/≥ queries) by setting `lowerValue[i] = Integer.MIN_VALUE` or `upperValue[i] = Integer.MAX_VALUE`.

    Ranges are inclusive. For exclusive ranges, pass `Math.addExact(lowerValue[i], 1)` or `Math.addExact(upperValue[i], -1)`.

    Parameters:
      `field` - field name. must not be `null`.
      `lowerValue` - lower portion of the range (inclusive). must not be `null`.
      `upperValue` - upper portion of the range (inclusive). must not be `null`.
    Returns:
      a query matching documents within this range.
    Throws:
      `IllegalArgumentException` - if `field` is null, if `lowerValue` is null, if `upperValue` is null, or if `lowerValue.length != upperValue.length`

  - ### newSetQuery

    public static Query newSetQuery(String field, int... values)
    Create a query matching any of the specified 1D values. This is the points equivalent of `TermsQuery`.
    Parameters:
      `field` - field name. must not be `null`.
      `values` - all values to match

  - ### newSetQuery

    public static Query newSetQuery(String field, Collection<Integer> values)
    Create a query matching any of the specified 1D values. This is the points equivalent of `TermsQuery`.
    Parameters:
      `field` - field name. must not be `null`.
      `values` - all values to match